/*
 * Try to be a little smarter about which kernel are we currently running
 */

#ifndef __rh_config_h__
#define __rh_config_h__

/*
 * First, get the version string for the running kernel from
 * /boot/kernel.h - initscripts should create it for us
 */

#include "/boot/kernel.h"

#if defined(__BOOT_KERNEL_DESKTOP_I586) && (__BOOT_KERNEL_DESKTOP_I586 == 1)
#define __module__desktop_i586
#endif

#if defined(__BOOT_KERNEL_DESKTOPSMP_I586) && (__BOOT_KERNEL_DESKTOPSMP_I586 == 1)
#define __module__desktopsmp_i586
#endif

#if defined(__BOOT_KERNEL_DESKTOP) && (__BOOT_KERNEL_DESKTOP == 1)
#define __module__desktop
#endif

#if defined(__BOOT_KERNEL_DESKTOPSMP) && (__BOOT_KERNEL_DESKTOPSMP == 1)
#define __module__desktopsmp
#endif

#if defined(__BOOT_KERNEL_LAPTOP) && (__BOOT_KERNEL_LAPTOP == 1)
#define __module__laptop
#endif

#if defined(__BOOT_KERNEL_LAPTOPSMP) && (__BOOT_KERNEL_LAPTOPSMP == 1)
#define __module__laptopsmp
#endif

#if defined(__BOOT_KERNEL_SERVER) && (__BOOT_KERNEL_SERVER == 1)
#define __module__server
#endif

#if defined(__BOOT_KERNEL_SERVERSMP) && (__BOOT_KERNEL_SERVERSMP == 1)
#define __module__serversmp
#endif

#ifdef __i386__
# ifdef __MODULE_KERNEL_i586
#  define __module__i586
#  ifdef __module__desktop_i586
#   define __module__i586_desktop_i586
#  endif
#  ifdef __module__desktopsmp_i586
#   define __module__i586_desktopsmp_i586
#  endif
#  ifdef __module__desktopsmp
#   define __module__i586_desktopsmp
#  endif
#  ifdef __module__laptop
#   define __module__i586_laptop
#  endif
#  ifdef __module__laptopsmp
#   define __module__i586_laptopsmp
#  endif
#  ifdef __module__server
#   define __module__i586_server
#  endif
#  ifdef __module__serversmp
#   define __module__i586_serversmp
#  endif
# elif defined(__MODULE_KERNEL_i686)
#  define __module__i686
#  ifdef __module__desktop
#   define __module__i686_desktop
#  endif
#  ifdef __module__desktopsmp
#   define __module__i686_desktopsmp
#  endif
#  ifdef __module__laptop
#   define __module__i686_laptop
#  endif
#  ifdef __module__laptopsmp
#   define __module__i686_laptopsmp
#  endif
#  ifdef __module__server
#   define __module__i686_server
#  endif
#  ifdef __module__serversmp
#   define __module__i686_serversmp
#  endif
# else
#  define __module__i386
#  ifdef __module__desktop_i586
#   define __module__i386_desktop_i586
#  endif
#  ifdef __module__desktopsmp_i586
#   define __module__i386_desktopsmp_i586
#  endif
#  ifdef __module__desktop
#   define __module__i386_desktop
#  endif
#  ifdef __module__desktopsmp
#   define __module__i386_desktopsmp
#  endif
#  ifdef __module__laptop
#   define __module__i386_laptop
#  endif
#  ifdef __module__laptopsmp
#   define __module__i386_laptopsmp
#  endif
#  ifdef __module__server
#   define __module__i386_server
#  endif
#  ifdef __module__serversmp
#    define __module__i386_serversmp
#  endif
# endif
#endif

#ifdef __x86_64__
# define __module__x86_64
# ifdef __module__desktop
#  define __module__x86_64_desktop
# endif
# ifdef __module__desktopsmp
#  define __module__x86_64_desktopsmp
# endif
# ifdef __module__laptop
#  define __module__x86_64_laptop
# endif
# ifdef __module__laptopsmp
#  define __module__x86_64_laptopsmp
# endif
# ifdef __module__server
#  define __module__x86_64_server
# endif
# ifdef __module__serversmp
#  define __module__x86_64_serversmp
# endif
#endif

#if defined(__module__smp) || defined(__module__desktopsmp_i586) || defined(__module__desktopsmp) || defined(__module__laptopsmp) || defined(__module__serversmp)
#define _ver_str(x) smp_ ## x
#else
#define _ver_str(x) x
#endif

#endif /* __rh_config_h__ */
